--版本控制：1.7.0 增加Self模式输出位置，除了DefaultChatFrame，还增加了UIErrorsFrame

local AddonName, Addon = ...

local Frame = Addon.Frame --Frame
local L = Addon.L --Localization

--Config Setting
local Config = Addon.Config --Config
--固定表
local MissReason = Addon.MissReason
local FailReason = Addon.FailReason
local RaidIconList = Addon.RaidIconList
--SpellList
local RunTime = Addon.RunTime

--本地化函数(提升运行效率)
local CombatLogGetCurrentEventInfo = CombatLogGetCurrentEventInfo
local SendChatMessage = SendChatMessage
local UnitIsGroupLeader = UnitIsGroupLeader
local UnitIsGroupAssistant = UnitIsGroupAssistant
local UnitIsPlayer = UnitIsPlayer
local UnitIsFriend = UnitIsFriend
local UnitIsUnit = UnitIsUnit
local UnitInBattleground = UnitInBattleground
local UnitName = UnitName
local UnitGUID = UnitGUID
local UnitDebuff = UnitDebuff
local UnitInRange = UnitInRange
local UnitIsConnected = UnitIsConnected
local UnitAffectingCombat = UnitAffectingCombat
-- local UnitIsDeadOrGhost = UnitIsDeadOrGhost
local GetRaidTargetIndex = GetRaidTargetIndex
local GetMinimapZoneText = GetMinimapZoneText
local GetNumGuildMembers = GetNumGuildMembers
local GetGuildRosterInfo = GetGuildRosterInfo
local IsInGroup	= IsInGroup
local IsInRaid = IsInRaid
local IsInGuild = IsInGuild
local IsInInstance = IsInInstance
local GetTime = GetTime
local FollowUnit = FollowUnit
local pairs = pairs
local print = print
local ChatEdit_SendText = ChatEdit_SendText
local ChatFrame10 = ChatFrame10
--Addon_MSG方法
local SendAddonMessage = C_ChatInfo.SendAddonMessage
local IsAddonMessagePrefixRegistered = C_ChatInfo.IsAddonMessagePrefixRegistered
local RegisterAddonMessagePrefix = C_ChatInfo.RegisterAddonMessagePrefix
--GUID
local PlayerGUID = UnitGUID("player")
local TargetGUID = nil --周边Target GUID
--延时过滤表
local OutputCache = {}
--发言Rank
local AnnounceTable = {}
--延时任务
local TaskTable = {}
--破控信息控制
local BreakTable = {}

--公共方法：
--读取/保存SpellWhisperDB
function Addon:UpdateTable(Target, Source)
	for k, v in pairs(Source) do
		if type(v) == "table" then
			if type(Target[k]) == "table" then
				self:UpdateTable(Target[k], v)
			else
				Target[k] = self:UpdateTable({}, v)
			end
		elseif type(Target[k]) ~= "table" then
			Target[k] = v
		end
	end
	return Target
end
--新建延时任务
function Addon:NewTask(Delay, Task)
	local TimeStamp = GetTime()*1000
	--补全slash
	if Task:sub(1, 1) ~= "/" then
		Task = "/" .. Task
	end
	local CacheTable = {}
	CacheTable["TimeStamp"] = TimeStamp
	CacheTable["Delay"] = Delay
	CacheTable["Task"] = Task
	for k, v in pairs(TaskTable) do
		if CacheTable["Delay"] == TaskTable[k]["Delay"] and CacheTable["Task"] == TaskTable[k]["Task"] then
			return
		end
	end
	table.insert(TaskTable, CacheTable)
	Addon.HasTask = true
	Frame:Show()
	print(string.format(L["|cFFBA55D3SpellWhisper|r Delay Command: |cFFCCA4E3%d|r [seconds] later do |cFFCCA4E3[%s]|r Task."], CacheTable["Delay"], CacheTable["Task"]))
end
--执行Command
function Addon:RunTask(Task)
	if Task then
		ChatFrame10.editBox:SetText(Task)
		ChatEdit_SendText(ChatFrame10.editBox)
		ChatFrame10.editBox:SetText("")	
	end
end
--测试当前的GUID是否为团队成员，并返回团队/小队代码（raidX，partyX, raidXtarget, partyXtarget, etc)
function Addon:GetTargetUnit(TestGUID) 
	if TestGUID then
		if TestGUID == PlayerGUID then
			return "player", "player"
		elseif TestGUID == UnitGUID("playerpet") then
			return "pet", "playerpet"
		else
			if IsInRaid() then
				for i=1, 40 do
					local u = "raid"..i
					if UnitGUID(u) == TestGUID then
						return "group", u
					end
				end
				for i=1, 40 do
					local u = "raid"..i.."pet"
					if UnitGUID(u) == TestGUID then
						return "pet", u
					end
				end
				for i=1, 40 do
					local u = "raid"..i.."target"
					if UnitGUID(u) == TestGUID then
						return "target", u
					end
				end
			elseif IsInGroup() then
				for i=1, 4 do
					local u = "party"..i
					if UnitGUID(u) == TestGUID then
						return "group", u
					end
				end
				for i=1, 4 do
					local u = "party"..i.."pet"
					if UnitGUID(u) == TestGUID then
						return "pet", u
					end
				end
				for i=1, 4 do
					local u = "party"..i.."target"
					if UnitGUID(u) == TestGUID then
						return "target", u
					end
				end
			end
		end
		if TestGUID == UnitGUID("playertarget") then
			return "target", "playertarget"
		end
	else
		return nil, nil
	end
end
--根据名字获取raid团队编号
function Addon:GetRaidIndex(TargetName)
	if IsInRaid() then
		for i=1, 40 do
			local u = "raid"..i
			if UnitName(u) and UnitName(u) == TargetName then
				return i
			end
		end
		return nil
	end
	return nil
end
--获取不含服务器名称的角色名
function Addon:GetShortName(SourceName) 
	if SourceName then
		return SourceName:match("^(%S*)%-") or SourceName
	else
		return nil
	end
end
--更新发言顺位
function Addon:SendAnnounceRank(Seed) --发送自身Rank
	if UnitInBattleground("player") then
		return
	end
	if UnitIsGroupLeader("player") then
		SendAddonMessage(Addon.PrefixSW, "80001", "raid")
	elseif IsInRaid() and UnitIsGroupAssistant("player") then
		SendAddonMessage(Addon.PrefixSW, tostring(40000 + Seed * 1000), "raid")
	elseif IsInRaid() then
		SendAddonMessage(Addon.PrefixSW, tostring(Seed * 1000), "raid")
	elseif IsInGroup() then
		SendAddonMessage(Addon.PrefixSW, tostring(math.random(1000, 40000)), "party")
	end
end
--删除不在队伍的成员信息
function Addon:DeleteVanishMember()
	local IsStillGroupMember = false
	if IsInRaid() then
		for k, v in pairs(AnnounceTable) do --遍历当前的AnnounceTable，清理已不在团队的成员Rank
			IsStillGroupMember = false
			for i=1, 40 do
				local u = "raid"..i
				if k == UnitName(u) then
					IsStillGroupMember = true
					break
				end
			end
			if not IsStillGroupMember then
				AnnounceTable[k] = nil
			end
		end
	elseif IsInGroup() then
		for k, v in pairs(AnnounceTable) do --遍历当前的AnnounceTable，清理已不在队伍的成员Rank
			if k == UnitName("player") then
				IsStillGroupMember = true
			else
				IsStillGroupMember = false
				for i=1, 4 do
					local u = "party"..i
					if k == UnitName(u) then
						IsStillGroupMember = true
						break
					end
				end
			end
			if not IsStillGroupMember then
				AnnounceTable[k] = nil
			end
		end
	else
		for k, v in pairs(AnnounceTable) do
			AnnounceTable[k] = nil
		end
	end
end
--比较发言顺序，返回是否允许发言bool值
function Addon:IsPlayerMuted()
	if UnitInBattleground("player") then
		return true
	end
	local Max = 0
	if IsInRaid() then
		for k, v in pairs(AnnounceTable) do
			local i = Addon:GetRaidIndex(k)
			if i then
				if UnitInRange("raid"..i) and UnitIsConnected("raid"..i) then
					if Max < AnnounceTable[k] then
						Max = AnnounceTable[k]
					end
				end
			end
		end	
		if AnnounceTable[UnitName("player")] == Max then
			return false
		else
			return true
		end
	elseif IsInGroup() then
		for k, v in pairs(AnnounceTable) do
			if Max < AnnounceTable[k] then
				Max = AnnounceTable[k]
			end
		end
		if AnnounceTable[UnitName("player")] == Max then
			return false
		else
			return true
		end
	end
	return true
end

--输出信息比较方法
--处理OutputCache表
function Addon:AddOutputCache(NewMessage, TargetName)
	if TargetName then
		OutputCache[GetTime()*1000] = NewMessage.."+"..TargetName
	else
		OutputCache[GetTime()*1000] = NewMessage
	end
end
--比较信息是否重复，重复返回true，不重复则返回false
function Addon:CompareOutputCache(Message, TargetName) 
	if Config.WaitTime == 0 then
		return false
	end
	if TargetName then
		Message = Message .. "+" .. TargetName
	end
	for k, v in pairs(OutputCache) do
		if OutputCache[k] then
			if Message == OutputCache[k] then
				return true
			end
		else
			return false
		end
	end
	return false
end

--信息报告方法
--治疗法术通告
function Addon:SendHealingMessage(SpellName, TargetName, FailedReason)
	if not Config.IsWhisperEnable or UnitInBattleground("player") then
		return
	end
	TargetName = Addon:GetShortName(TargetName)
	local msg = string.format(L["SPELLWHISPER_TEXT_HEALINGFAILED"], SpellName, FailedReason)
	if not Addon:CompareOutputCache(msg, TargetName) then
		SendChatMessage(msg, "whisper", nil, TargetName)
	end
end
--战场信息输出（专用）
function Addon:SendBGMessage(SpellName, CasterName, TargetName)
	if not Config.IsBGWarningEnable or Config.OutputChannel == "off" then
		return
	end
	CasterName = Addon:GetShortName(CasterName)
	TargetName = Addon:GetShortName(TargetName)
	local SubZoneName = GetMinimapZoneText()
	local msg = string.format(L["SPELLWHISPER_TEXT_BGWARNING"], CasterName, SpellName, TargetName, SubZoneName)
	SendChatMessage(msg, "instance_chat")
end
--CC/Interrupt/missed通告，OtherInfo可以是被打破的控制技能、被打断的法术或者Miss原因
function Addon:SendWarningMessage(WarningType, CasterName, SpellName, TargetName, OtherInfo, TargetIconIndex, TargetUnitGUID)
	if Addon:IsPlayerMuted() or Config.OutputChannel == "off" then
		return
	end
	if Config.SelfOnly and CasterName ~= UnitName("player") then
		return
	end
	local channel = Config.OutputChannel
	CasterName = Addon:GetShortName(CasterName)
	TargetName = Addon:GetShortName(TargetName)
	if IsInRaid() and not (UnitIsGroupAssistant("player") or UnitIsGroupLeader("player")) and channel == "Raid_Warning" then
		channel = "raid"
	elseif IsInGroup() and not IsInRaid() and (channel == "raid" or channel == "Raid_Warning") then
		channel = "party"
	end
	local msg = nil --待输出内容
	if TargetIconIndex~=0 then
		TargetName = RaidIconList[TargetIconIndex]..TargetName
	end
	if WarningType == "BROKEN" then --破控
		if BreakTable[TargetUnitGUID] then
			if GetTime() - BreakTable[TargetUnitGUID] < Config.BreakTime then
				return
			end
		end
		msg = string.format(L["SPELLWHISPER_TEXT_BROKEN"], CasterName, SpellName, TargetName, OtherInfo)
		BreakTable[TargetUnitGUID] = GetTime()
	elseif WarningType == "INTERRUPT" then --打断
		msg = string.format(L["SPELLWHISPER_TEXT_INTERRUPT"], CasterName, SpellName, TargetName, OtherInfo)
	elseif WarningType == "MISSED" then --抵抗/失误
		msg = string.format(L["SPELLWHISPER_TEXT_MISSED"], CasterName, SpellName, TargetName, OtherInfo)
	elseif WarningType == "DISPEL" then --驱散
		msg = string.format(L["SPELLWHISPER_TEXT_DISPEL"], CasterName, SpellName, TargetName, OtherInfo)
	end
	if not Addon:CompareOutputCache(msg) then
		if channel == "hud" then
			UIErrorsFrame:AddMessage(msg)
		elseif channel == "self" then
			print(msg)
		else
			if (channel == "raid" or channel == "Raid_Warning") and UnitInBattleground("player") then
				channel = "instance_chat"
			end
			SendChatMessage(msg, channel)
		end
	end
end
--施法相关通告（开始、成功）
function Addon:SendAnnounceMessage(AnnounceChannel, AnnounceReason, AnnounceType, SpellName, TargetName, TargetIconIndex)
	local channel = Config.OutputChannel
	if IsInRaid() and not (UnitIsGroupAssistant("player") or UnitIsGroupLeader("player")) and channel == "Raid_Warning" then
		channel = "raid"
	elseif IsInGroup() and not IsInRaid() and (channel == "raid" or channel == "Raid_Warning") then
		channel = "party"
	end
	local msg = nil --待输出内容
	if AnnounceChannel == "group" and AnnounceReason == "start" then --开始施法通告，有益/有害共用
		if TargetIconIndex~=0 then
			msg = string.format(L["SPELLWHISPER_TEXT_SENTTOGROUPSTART"], SpellName, RaidIconList[TargetIconIndex]..TargetName)
		else
			msg = string.format(L["SPELLWHISPER_TEXT_SENTTOGROUPSTART"], SpellName, TargetName)
		end
		if not Addon:CompareOutputCache(msg) then
			if channel == "off" then
				return
			elseif channel == "hud" then
				UIErrorsFrame:AddMessage(msg)
			elseif channel == "self" then
				print(msg)
			else
				if channel == "raid" and UnitInBattleground("player") then
					channel = "instance_chat"
				end
				SendChatMessage(msg, channel)
			end
		end
	elseif AnnounceChannel == "group" and AnnounceReason == "done" then --完成施法通告，有益/有害共用
		if TargetIconIndex~=0 then
			msg = string.format(L["SPELLWHISPER_TEXT_SENTTOGROUPDONE"], SpellName, RaidIconList[TargetIconIndex]..TargetName)
		else
			msg = string.format(L["SPELLWHISPER_TEXT_SENTTOGROUPDONE"], SpellName, TargetName)
		end
		if not Addon:CompareOutputCache(msg) then
			if channel == "off" then
				return
			elseif channel == "hud" then
				UIErrorsFrame:AddMessage(msg)
			elseif channel == "self" then
				print(msg)
			else
				if channel == "raid" and UnitInBattleground("player") then
					channel = "instance_chat"
				end
				SendChatMessage(msg, channel)
			end
		end
	elseif AnnounceChannel == "whisper" and AnnounceReason == "start" and AnnounceType == "help" then --开始施法密语，有益
		if not Config.IsWhisperEnable or UnitInBattleground("player") then
			return
		end
		msg = string.format(L["SPELLWHISPER_TEXT_SENTTOPLAYERSTART"], SpellName)
		if TargetName ~= UnitName("player") then
			if not Addon:CompareOutputCache(msg, TargetName) then
				SendChatMessage(msg, AnnounceChannel, nil, TargetName)
			end
		end
	elseif AnnounceChannel == "whisper" and AnnounceReason == "done" and AnnounceType == "help" then --完成施法密语，有益
		if not Config.IsWhisperEnable or UnitInBattleground("player") then
			return
		end
		msg = string.format(L["SPELLWHISPER_TEXT_SENTTOPLAYERDONE"], SpellName)
		if TargetName ~= UnitName("player") then
			if not Addon:CompareOutputCache(msg, TargetName) then
				SendChatMessage(msg, AnnounceChannel, nil, TargetName)
			end
		end
	elseif AnnounceChannel == "whisper" and AnnounceReason == "start" and AnnounceType == "harm" then --开始控制技能施法密语
		if not Config.IsWhisperEnable or UnitInBattleground("player") then
			return
		end
		if not Config.ToTWarningEnable then
			return
		end
		if TargetIconIndex~=0 then
			msg = string.format(L["SPELLWHISPER_TEXT_SENTTOPLAYERTARGETTHETARGET"], SpellName, RaidIconList[TargetIconIndex]..TargetName)
		else
			msg = string.format(L["SPELLWHISPER_TEXT_SENTTOPLAYERTARGETTHETARGET"], SpellName, TargetName)
		end
		if IsInRaid() then
			for i=1, 40 do
				local u = "raid"..i
				if UnitGUID(u.."target") == TargetGUID and not UnitIsUnit(u, "player") then
					if not Addon:CompareOutputCache(msg, UnitName(u)) then
						SendChatMessage(msg, AnnounceChannel, nil, UnitName(u))
					end
				end
			end
		elseif IsInGroup() then
			for i=1, 4 do
				local u = "party"..i
				if UnitGUID(u.."target") == TargetGUID then
					if not Addon:CompareOutputCache(msg, UnitName(u)) then
						SendChatMessage(msg, AnnounceChannel, nil, UnitName(u))
					end
				end
			end
		end
	elseif AnnounceChannel == "whisper" and AnnounceReason == "done" and AnnounceType == "harm" then --完成施法密语通告，有害
		return
	end
end

--Register Events 注册事件
--装载和退出
Frame:RegisterEvent("ADDON_LOADED")
Frame:RegisterEvent("PLAYER_LOGOUT")
--战斗信息处理
--Frame:RegisterEvent("UNIT_SPELLCAST_SENT")
Frame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
--文字信息处理
Frame:RegisterEvent("CHAT_MSG_WHISPER")
Frame:RegisterEvent("CHAT_MSG_WHISPER_INFORM")
Frame:RegisterEvent("CHAT_MSG_PARTY")
Frame:RegisterEvent("CHAT_MSG_PARTY_LEADER")
Frame:RegisterEvent("CHAT_MSG_RAID")
Frame:RegisterEvent("CHAT_MSG_RAID_LEADER")
Frame:RegisterEvent("CHAT_MSG_INSTANCE_CHAT")
Frame:RegisterEvent("CHAT_MSG_INSTANCE_CHAT_LEADER")
Frame:RegisterEvent("CHAT_MSG_SAY")
Frame:RegisterEvent("GROUP_ROSTER_UPDATE")
Frame:RegisterEvent("CHAT_MSG_ADDON")
Frame:RegisterEvent("PLAYER_LOGOUT")
Frame:RegisterEvent("PLAYER_REGEN_ENABLED")
--脚本交易相关
Frame:RegisterEvent("MAIL_SHOW")
Frame:RegisterEvent("MAIL_CLOSED")
Frame:RegisterEvent("TRADE_SHOW")
--移动相关
Frame:RegisterEvent("AUTOFOLLOW_END")

--Update处理（防止重复提示，处理延时任务）
local LastScan = 0
Frame:SetScript("OnUpdate", function(self, lastupdate)
	if not Config.IsEnable then
		Frame:Hide()
		return
	end
	if Config.WaitTime == 0 and not Addon.HasTask then
		Frame:Hide()
		return
	end
	local NowScan = math.floor(GetTime()*10)
	if NowScan == LastScan then
		return
	end
	LastScan = NowScan
	-- 过滤重复信息
	if Config.WaitTime ~= 0 then
		for k, v in pairs(OutputCache) do
			if NowScan*100 > k + Config.WaitTime*1000 then
				OutputCache[k] = nil
			end
		end
	end
	-- 执行延时任务
	if Addon.HasTask and #TaskTable > 0 then
		for i = #TaskTable, 1, -1 do
			if NowScan*100 >= TaskTable[i].TimeStamp + TaskTable[i].Delay*1000 then
				Addon:RunTask(TaskTable[i].Task)
				table.remove(TaskTable, i)
			end
		end
		if TaskTable == {} then
			Addon.HasTask = false
		end
	end
	-- 2秒一次自动跟随
	if Addon.Followed.UnitIndex ~= "player" then
		if GetTime() - Addon.Followed.StartTime > 2 then
			Addon.Followed.StartTime = GetTime()
			if not UnitIsConnected(Addon.Followed.UnitIndex) then -- 掉线停止跟随
				Addon.Followed.UnitIndex = "player"
				Addon.Followed.GUID = ""
				FollowUnit("player")
			elseif (not Config.CombatFollow and UnitAffectingCombat(Addon.Followed.UnitIndex)) or not UnitInRange(Addon.Followed.UnitIndex) then -- 战斗状态或超距离原地等候，2秒一次继续扫描
				FollowUnit("player")
			else
				FollowUnit(Addon.Followed.UnitIndex)
			end
		end
	end
end)

--Event处理分配
Frame:SetScript("OnEvent", function(self, event, ...)
	if type(self[event]) == "function" then
		return self[event](self, ...)
	end
end)


--插件装载
function Frame:ADDON_LOADED(Name)
	if Name ~= AddonName then
		return
	end
	self:UnregisterEvent("ADDON_LOADED") --完成加载后反注册事件
	do
		local VerNumString = string.gsub(Addon.Version, "%.", "")
		Addon.VerNum = tonumber(VerNumString)
	end
	-- 两种情况，如果没有SpellWhisperDB或者SpellWhisperDB中某个表不存在，则创建该表，但不用新表覆盖（读取Core中的默认值）
	-- 如果SpellWhisperDB及SpellWhisperDB中的某个表存在，则用SpellWhisperDB中的子表覆盖，避免删不掉现象
	if not SpellWhisperDB then
		SpellWhisperDB = {}
	end
	if not SpellWhisperDB.Config then
		SpellWhisperDB.Config = {}
	end
	if not SpellWhisperDB.SpellList then
		SpellWhisperDB.SpellList = {}
		Addon:UpdateTable(RunTime, Addon.Default)
	end
	-- 用SpellWhisperDB更新config和SpellList表
	Addon:UpdateTable(Config, SpellWhisperDB.Config)
	Addon:UpdateTable(RunTime, SpellWhisperDB.SpellList)
	-- 注册Prefix：SWPX
	if not IsAddonMessagePrefixRegistered(Addon.PrefixSW) then
		RegisterAddonMessagePrefix(Addon.PrefixSW)
	end
	if IsInGuild() then
		SendAddonMessage(Addon.PrefixSW, tostring(Addon.VerNum), "guild")
	end
	if Config.IsEnable and Config.WaitTime > 0 and not Frame:IsShown() then
		Frame:Show()
	else
		Frame:Hide()
	end
	-- 解决CN客户端部分字符乱码的问题
	if GetCVar("portal") == "CN" then
		ConsoleExec("portal US")
		ConsoleExec("profanityFilter 0")
		ConsoleExec("overrideArchive 0")
	else
		Config.PreventTrade = false
	end
	local msg = string.format(L["|cFFBA55D3SpellWhisper|r v%s|cFFB0C4DE is Loaded.|r"], Addon.Version)
	if Config.IsEnable then
		print(msg..L["Now is |cFF00FFFFEnabled|r."])
	else
		print(msg..L["Now is |cFF00FFFFDisabled|r."])
	end
end
-- 退出游戏
function Frame:PLAYER_LOGOUT()
	-- 将数据存入SpellWhisperDB（保存文件）
	SpellWhisperDB = {
		["Config"] = {},
		["SpellList"] = {},
	}
	Addon:UpdateTable(SpellWhisperDB.Config, Config)
	Addon:UpdateTable(SpellWhisperDB.SpellList, Addon.RunTime)
end

--确定发言等级
function Frame:GROUP_ROSTER_UPDATE() --发言者同步, 队伍成员变化时Fire
	if Addon.IsEnable == "off" then
		return
	end
	if Config.OutputChannel == "off" or Config.OutputChannel == "self" then
		return
	end
	Addon:DeleteVanishMember()
	if IsInRaid() then
		Addon:SendAnnounceRank(41 - Addon:GetRaidIndex(UnitName("player")))
	elseif IsInGroup() then
		Addon:SendAnnounceRank(0)
	end
	if Addon.Followed.UnitIndex ~= "player" then
		local t, u = Addon:GetTargetUnit(Addon.Followed.GUID)
		if t == "group" then
			Addon.Followed.UnitIndex = u
		else
			Addon.Followed.UnitIndex = "player"
			Addon.Followed.GUID = ""
		end
	end
end

function Frame:CHAT_MSG_ADDON(...) -- 同步Rank，决定谁能发言，提示更新信息
	if not Config.IsEnable then
		return
	end

	local arg = {...}

	if arg[1] == Addon.PrefixSW then
		local AddonChannelMsg = tonumber(arg[2])
		if AddonChannelMsg >= 1000 and AddonChannelMsg <= 81001 and (arg[3] == "PARTY" or arg[3] == "RAID") then
			if Config.OutputChannel == "off" or Config.OutputChannel == "self" then
				return
			end
			AnnounceTable[Addon:GetShortName(arg[4])] = tonumber(arg[2])
		elseif AddonChannelMsg < 1000 and arg[3] == "GUILD" then
			--todo:比较版本号，提示更新
			if AddonChannelMsg > Addon.VerNum then
				print(string.format(L["|cFFBA55D3SpellWhisper|r v%s is |cFFFF4C00Out of date|r. Goto %s for |cFFF48CBANew Version.|r"], Addon.Version, L["Feedback & Update Link"]))
			end
		end
	end
end

function Frame:CHAT_MSG_WHISPER(...) --接收密语--arg[1]对话内容，arg[12]GUID
	if not Config.IsEnable or UnitInBattleground("player") then
		return
	end
	local arg = {...}

	local t, u = Addon:GetTargetUnit(arg[12]) -- 根据密语对象GUID判断是否为团队/小队成员
	if t == "group" then
		if Config.StartFollow ~= "" and arg[1] == Config.StartFollow then --跟随
			if not UnitInRange(u) then
				SendChatMessage(L["SPELLWHISPER_TEXT_FOLLOWFAILED_OUTOFRANGE"], "whisper", nil, UnitName(u))
			else
				FollowUnit(u)
				Addon.Followed.UnitIndex = u
				Addon.Followed.GUID = arg[12]
				Addon.Followed.StartTime = GetTime()
				SendChatMessage(L["SPELLWHISPER_TEXT_FOLLOWREPLY"], "whisper", nil, UnitName(u))
			end
		elseif Config.StopFollow ~= "" and arg[1] == Config.StopFollow then --停止跟随
			FollowUnit("player")
			Addon.Followed.UnitIndex = "player"
			Addon.Followed.GUID = ""
			SendChatMessage(L["SPELLWHISPER_TEXT_STOPFOLLOWREPLY"], "whisper", nil, UnitName(u))
		elseif Config.CombatFollowSwitchKey ~= "" and arg[1] == Config.CombatFollowSwitchKey then
			if Config.CombatFollow then
				Config.CombatFollow = false
				SendChatMessage(L["SPELLWHISPER_TEXT_CHANGEFOLLOWMODEOFF"], "whisper", nil, UnitName(u))
			else
				Config.CombatFollow = true
				SendChatMessage(L["SPELLWHISPER_TEXT_CHANGEFOLLOWMODEON"], "whisper", nil, UnitName(u))
			end
			Addon.ScrollFrame:ConfigRefresh()
		end
	end
end

function Frame:CHAT_MSG_WHISPER_INFORM(NewMessage, TargetName) --发送密语--arg[1]对话内容，arg[2]发送对象
	if not Config.IsEnable or Config.WaitTime == 0 then
		return
	end
	Addon:AddOutputCache(NewMessage, Addon:GetShortName(TargetName))
end

function Frame:CHAT_MSG_SAY(NewMessage) --接收说话频道信息
	if not Config.IsEnable or Config.WaitTime == 0 then
		return
	end
	Addon:AddOutputCache(NewMessage, nil)
end

function Frame:CHAT_MSG_PARTY(NewMessage) --接收队伍对话信息
	if NewMessage == Config.StopFollow then
		Addon.Followed.UnitIndex = "player"
		Addon.Followed.GUID = ""
		FollowUnit("player")
		return
	end
	if not Config.IsEnable or Config.WaitTime == 0 then
		return
	end
	Addon:AddOutputCache(NewMessage, nil)
end

function Frame:CHAT_MSG_PARTY_LEADER(NewMessage) --队长信息
	if NewMessage == Config.StopFollow then
		Addon.Followed.UnitIndex = "player"
		Addon.Followed.GUID = ""
		FollowUnit("player")
		return
	end
	if not Config.IsEnable or Config.WaitTime == 0 then
		return
	end
	Addon:AddOutputCache(NewMessage, nil)
end

function Frame:CHAT_MSG_RAID(NewMessage) --raid频道信息
	if NewMessage == Config.StopFollow then
		Addon.Followed.UnitIndex = "player"
		Addon.Followed.GUID = ""
		FollowUnit("player")
		return
	end
	if not Config.IsEnable or Config.WaitTime == 0 then
		return
	end
	Addon:AddOutputCache(NewMessage, nil)
end

function Frame:CHAT_MSG_RAID_LEADER(NewMessage) --RaidLeader频道
	if NewMessage == Config.StopFollow then
		Addon.Followed.UnitIndex = "player"
		Addon.Followed.GUID = ""
		FollowUnit("player")
		return
	end
	if not Config.IsEnable or Config.WaitTime == 0 then
		return
	end
	Addon:AddOutputCache(NewMessage, nil)
end

function Frame:CHAT_MSG_INSTANCE_CHAT(NewMessage) --战场频道
	if not Config.IsEnable or Config.WaitTime == 0 then
		return
	end
	Addon:AddOutputCache(NewMessage, nil)
end

function Frame:CHAT_MSG_INSTANCE_CHAT_LEADER(NewMessage) --战场Leader频道
	if not Config.IsEnable or Config.WaitTime == 0 then
		return
	end
	Addon:AddOutputCache(NewMessage, nil)
end

-- 战斗结束清空BreakTable
function Frame:PLAYER_REGEN_ENABLED()
	if BreakTable then
		BreakTable = {}
	end
end
-- COMBAT_LOG_EVENT_UNFILTERED 战斗信息处理
function Frame:COMBAT_LOG_EVENT_UNFILTERED(...)
	if not Config.IsEnable or not IsInGroup() then
		return
	end
	local arg ={CombatLogGetCurrentEventInfo()} --COMBAT_LOG_EVENT_UNFILTERED 事件参数Payload

	-- for k, v in pairs(arg) do
	-- 	if arg[k] then
	-- 		print("arg["..k.."] = "..arg[k])
	-- 	end
	-- end

	local SpellName = nil
	local TypeHelpHarm = nil
	local InInstance, InstanceType = IsInInstance()

	if arg[2] == "SPELL_CAST_FAILED" and arg[4] == PlayerGUID and InInstance then --治疗法术失败提示
		local FailedReason = nil
		for k, v in pairs(FailReason) do
			if arg[15] == FailReason[k] then
				FailedReason = arg[15] --失败原因arg[15]
				break
			end
		end
		if FailedReason then
			for k, v in pairs(RunTime.Healing) do
				if arg[13] == RunTime.Healing[k] then
					SpellName = arg[13] --失败法术arg[13]
					break
				end
			end
			local CurrentTarget = nil
			if SpellName and UnitName("mouseover") and UnitIsPlayer("mouseover") and UnitIsFriend("player", "mouseover") then
				CurrentTarget = "mouseover"
			elseif SpellName and UnitName("target") and UnitIsPlayer("target") and UnitIsFriend("player", "target") then
				CurrentTarget = "target"
			elseif SpellName and UnitName("targettarget") and UnitIsPlayer("targettarget") and not UnitIsFriend("player", "target") and UnitIsFriend("player", "targettarget") then
				CurrentTarget = "targettarget"
			end
			if CurrentTarget then
				Addon:SendHealingMessage(SpellName, UnitName(CurrentTarget), FailedReason)
			end
		end
	 elseif arg[2] == "SPELL_MISSED" and InInstance then	--法术未成功通告
		local CasterType = Addon:GetTargetUnit(arg[4])
		if CasterType == "group" or CasterType == "pet" or arg[4] == PlayerGUID then
			local MissedReason = nil
			for k, v in pairs(MissReason) do
				if arg[15] == k then
					MissedReason = MissReason[k]
					break
				end
			end
			if MissedReason then
				if not SpellName then
					for k, v in pairs(RunTime.Other) do --是否为其他需要通告的技能
						if arg[13] == RunTime.Other[k] then
							SpellName = arg[13]
							break
						end
					end
				end
				if not SpellName then
					for k, v in pairs(RunTime.CastHarm) do --是否为施法控制技能
						if arg[13] == RunTime.CastHarm[k] then
							SpellName = arg[13]
							break
						end
					end
				end
				if not SpellName then
					for k, v in pairs(RunTime.InstantHarm) do --是否为瞬发控制技能
						if arg[13] == RunTime.InstantHarm[k] then
							SpellName = arg[13]
							break
						end
					end
				end
				if SpellName then
					local t, u = Addon:GetTargetUnit(arg[8]) --获取miss对象的Unit代码
					if t == "target" and u then
						if GetRaidTargetIndex(u) then
							Addon:SendWarningMessage("MISSED", arg[5], SpellName, arg[9], MissedReason, GetRaidTargetIndex(u), nil) 	--arg[5]施法者名字，arg[9]目标名字
						else
							Addon:SendWarningMessage("MISSED", arg[5], SpellName, arg[9], MissedReason, 0, nil) 	--arg[5]施法者名字，arg[9]目标名字
						end
					end
				end
			end
		end
	elseif arg[2] == "SPELL_INTERRUPT" and InInstance then --打断通告
		local CasterType = Addon:GetTargetUnit(arg[4])
		if CasterType == "group" or CasterType == "pet" or arg[4] == PlayerGUID then
			local t, u = Addon:GetTargetUnit(arg[8]) --获取miss对象的Unit代码
			if t == "target" and u and not UnitIsFriend("player", u) then
			--arg[5]打断者名字，arg[13]打断技能，arg[9]被打断者名字，arg[16]被打断的技能
				if GetRaidTargetIndex(u) then
					Addon:SendWarningMessage("INTERRUPT", arg[5], arg[13], arg[9], arg[16], GetRaidTargetIndex(u), nil)
				else
					Addon:SendWarningMessage("INTERRUPT", arg[5], arg[13], arg[9], arg[16], 0, nil)
				end
			end
		end
	elseif arg[2] == "SPELL_DISPEL" then --进攻驱散提示
		local CasterType = Addon:GetTargetUnit(arg[4])
		if CasterType == "group" or CasterType == "pet" or arg[4] == PlayerGUID then
			local t, u = Addon:GetTargetUnit(arg[8]) --被驱散对象的Unit代码
			if t == "target" and u and not UnitIsFriend("player", u) then
				if GetRaidTargetIndex(u) then
					Addon:SendWarningMessage("DISPEL", arg[5], arg[13], arg[9], arg[16], GetRaidTargetIndex(u), nil)
				else
					Addon:SendWarningMessage("DISPEL", arg[5], arg[13], arg[9], arg[16], 0, nil)
				end
			end
		end
	elseif (arg[2] == "SPELL_AURA_BROKEN_SPELL" or arg[2] == "SPELL_AURA_BROKEN") and InInstance then --破控警告
		local CasterType = Addon:GetTargetUnit(arg[4])
		if CasterType == "group" or CasterType == "pet" or arg[4] == PlayerGUID then
			if not arg[16] then --SWING模式下arg补全
				arg[16] = L["SPELLWHISPER_TEXT_SWINGATTACK"]
			end
			local t, u = Addon:GetTargetUnit(arg[8]) --获取破除控制对象的Unit代码
			if t == "target" and u and not UnitIsFriend("player", u) then	--arg[5]破控者名字，arg[16]破控技能, arg[9]失去控制对象名字，arg[13]被打破的控制技能
				if GetRaidTargetIndex(u) then
					Addon:SendWarningMessage("BROKEN", arg[5], arg[16], arg[9], arg[13], GetRaidTargetIndex(u), arg[8])
				else
					Addon:SendWarningMessage("BROKEN", arg[5], arg[16], arg[9], arg[13], 0, arg[8])
				end
			end
		end
	elseif arg[2] == "SPELL_CAST_START" and arg[4] == PlayerGUID then
		local IsIgnoreSpell = false
		TargetGUID = nil
		if not SpellName then
			for k, v in pairs(RunTime.CastHelp) do --监控有益施法法术
				if arg[13] == RunTime.CastHelp[k] then
					SpellName = arg[13]
					TypeHelpHarm = "help"
					break
				end
			end
		end
		if not SpellName then
			for k, v in pairs(RunTime.CastHarm) do --监控有害施法法术
				if arg[13] == RunTime.CastHarm[k] then
					SpellName = arg[13]
					TypeHelpHarm = "harm"
					break
				end
			end
		end
		if SpellName then
			for k, v in pairs(RunTime.Ignore) do --排除忽略列表
				if SpellName == RunTime.Ignore[k] then
					IsIgnoreSpell = true
					break
				end
			end
			local CurrentTarget = nil
			if TypeHelpHarm == "harm" then
				if UnitName("mouseover") and not UnitIsFriend("player", "mouseover") then
					CurrentTarget = "mouseover"
				elseif UnitName("target") and not UnitIsFriend("player", "target") then
					CurrentTarget = "target"
				end
			elseif TypeHelpHarm == "help" then
				if UnitName("mouseover") and UnitIsFriend("player", "mouseover") then
					CurrentTarget = "mouseover"
				elseif UnitName("target") and UnitIsFriend("player", "target") then
					CurrentTarget = "target"
				end
			end
			if CurrentTarget then
				TargetGUID = UnitGUID(CurrentTarget) --建立施法状态，以便通告
				for i=1, 40 do --查找现有debuff，如存在，则施法为renew，不重复提示
					if not UnitDebuff(CurrentTarget, i) then --如无debuff，则跳出查找环节
						break
					elseif UnitDebuff(CurrentTarget, i) == SpellName then
						return
					end
				end
				if GetRaidTargetIndex(CurrentTarget) then
					Addon:SendAnnounceMessage("group", "start", TypeHelpHarm, SpellName, UnitName(CurrentTarget), GetRaidTargetIndex(CurrentTarget))
					if CurrentTarget and not IsIgnoreSpell then
						if TypeHelpHarm == "help" and UnitIsPlayer(CurrentTarget) then
							-- Addon:SendAnnounceMessage("whisper", "start", TypeHelpHarm, SpellName, UnitName(CurrentTarget), GetRaidTargetIndex(CurrentTarget))
						elseif TypeHelpHarm == "harm" then
							Addon:SendAnnounceMessage("whisper", "start", TypeHelpHarm, SpellName, UnitName(CurrentTarget), GetRaidTargetIndex(CurrentTarget))
						end
					end
				else
					Addon:SendAnnounceMessage("group", "start", TypeHelpHarm, SpellName, UnitName(CurrentTarget), 0)
					if CurrentTarget and not IsIgnoreSpell then
						if TypeHelpHarm == "help" and UnitIsPlayer(CurrentTarget) then
							-- Addon:SendAnnounceMessage("whisper", "start", TypeHelpHarm, SpellName, UnitName(CurrentTarget), 0)
						elseif TypeHelpHarm == "harm" then
							Addon:SendAnnounceMessage("whisper", "start", TypeHelpHarm, SpellName, UnitName(CurrentTarget), 0)
						end
					end
				end
			end
		end
	elseif arg[2] == "SPELL_CAST_SUCCESS" and arg[4] == PlayerGUID then --增益通告:arg[4]施法者GUID，arg[9]目标名字，arg[8]目标GUID(不再使用GUID)
		if not SpellName then
			for k, v in pairs(RunTime.InstantHelp) do --遍历，寻找瞬发增益
				if arg[13] == RunTime.InstantHelp[k] then
					SpellName = arg[13]
					TypeHelpHarm = "help"
					break
				end
			end
		end
		if not SpellName then
			for k, v in pairs(RunTime.CastHelp) do --遍历，寻找施法增益
				if arg[13] == RunTime.CastHelp[k] then
					SpellName = arg[13]
					TypeHelpHarm = "help"
					break
				end
			end
		end
		if SpellName then
			local NowGUID = nil
			if arg[9] then
				NowGUID = arg[8]
			else
				NowGUID = TargetGUID or PlayerGUID
			end
			local _, u = Addon:GetTargetUnit(NowGUID)
			if UnitIsPlayer(u) then
				if GetRaidTargetIndex(u) then
					Addon:SendAnnounceMessage("group", "done", TypeHelpHarm, SpellName, UnitName(u), GetRaidTargetIndex(u))
					Addon:SendAnnounceMessage("whisper", "done", TypeHelpHarm, SpellName, UnitName(u), GetRaidTargetIndex(u))
				else
					Addon:SendAnnounceMessage("group", "done", TypeHelpHarm, SpellName, UnitName(u), 0)
					Addon:SendAnnounceMessage("whisper", "done", TypeHelpHarm, SpellName, UnitName(u), 0)
				end
			end
		end
	elseif arg[2] == "SPELL_AURA_APPLIED" and (arg[4] == PlayerGUID or (arg[8] == PlayerGUID and UnitInBattleground("player"))) then
		if not SpellName then
			for k, v in pairs(RunTime.InstantHarm) do
				if arg[13] == RunTime.InstantHarm[k] then
					SpellName = RunTime.InstantHarm[k]
					TypeHelpHarm = "harm"
					break
				end
			end
		end
		if not SpellName then
			for k, v in pairs(RunTime.CastHarm) do
				if arg[13] == RunTime.CastHarm[k] then
					SpellName = RunTime.CastHarm[k]
					TypeHelpHarm = "harm"
					break
				end
			end
		end
		if not SpellName then
			for k, v in pairs(RunTime.SelfBuff) do
				if arg[13] == RunTime.SelfBuff[k] then
					SpellName = RunTime.SelfBuff[k]
					TypeHelpHarm = "help"
					break
				end
			end
		end
		if SpellName then
			local t, u = Addon:GetTargetUnit(arg[8]) --arg[8] 受影响对象的GUID
			if arg[4] == PlayerGUID then
				if t == "target" and not UnitIsFriend("player", u) then
					if GetRaidTargetIndex(u) then
						Addon:SendAnnounceMessage("group", "done", TypeHelpHarm, SpellName, arg[9], GetRaidTargetIndex(u))
					else
						Addon:SendAnnounceMessage("group", "done", TypeHelpHarm, SpellName, arg[9], 0)
					end
				elseif t == "player" then
					if GetRaidTargetIndex(u) then
						Addon:SendAnnounceMessage("group", "done", TypeHelpHarm, SpellName, arg[9], GetRaidTargetIndex(u))
					else
						Addon:SendAnnounceMessage("group", "done", TypeHelpHarm, SpellName, arg[9], 0)
					end
				end
			elseif UnitInBattleground("player") and t == "player" then
				if not arg[5] then
					arg[5] = L["SPELLWHISPER_TEXT_UNKNOWN"]
				end
				Addon:SendBGMessage(SpellName, arg[5], arg[9])
			end
		end
	end
end

-- 阻止小号交易相关功能
-- 屏蔽外会和团队之外的人交易
function Frame:TRADE_SHOW()
	if not Config.PreventTrade then
		return
	end
	local RequestName = UnitName("npc")
	local TargetCanTradeMe = false
	if IsInGuild() and not TargetCanTradeMe then
		for i = 1, GetNumGuildMembers() do
			local GuildMemberName = GetGuildRosterInfo(i)
			if Addon:GetShortName(GuildMemberName) == RequestName then
				TargetCanTradeMe = true
				break
			end
		end
	end
	if IsInRaid() and not TargetCanTradeMe then
		for i = 1, 40 do
			local u = "raid"..i
			if UnitName(u) and UnitName(u) == RequestName then
				TargetCanTradeMe = true
				break
			end
		end
	elseif IsInGroup() and not TargetCanTradeMe then
		for i = 1, 4 do
			local u = "party"..i
			if UnitName(u) and UnitName(u) == RequestName then
				TargetCanTradeMe = true
				break
			end
		end
	end
	if UnitName("target") == RequestName and not TargetCanTradeMe then
		TargetCanTradeMe = true
	end
	if UnitGUID("npc") and not TargetCanTradeMe then
		if C_FriendList.IsFriend(UnitGUID("npc"))  then
			TargetCanTradeMe = true
		end
	end
	if not TargetCanTradeMe then
		--CancelTradeAccept()
		CloseTrade()
	end
end
-- 关闭邮箱启用自动接受交易
function Frame:MAIL_CLOSED()
	SetCVar("blockTrades",0)
end
-- 开启邮箱界面自动阻止交易
function Frame:MAIL_SHOW()
	SetCVar("blockTrades",1)
end

-- 手动停止跟随
function Frame:AUTOFOLLOW_END()
	if Addon.Followed.UnitIndex ~= "player" then
		if GetTime() - Addon.Followed.StartTime > 0.1 then
			SendChatMessage(L["SPELLWHISPER_TEXT_STOPFOLLOW_MANUALLY"], "whisper", nil, UnitName(Addon.Followed.UnitIndex))
			Addon.Followed.UnitIndex = "player"
			Addon.Followed.GUID = ""
		end
	end
end